using System;
using System.Windows.Forms;
using System.ServiceProcess;

namespace ListServices
{
	public class Form1 : System.Windows.Forms.Form
	{
    private System.Windows.Forms.ColumnHeader chName;
    private System.Windows.Forms.ColumnHeader chStatus;
    private System.Windows.Forms.ColumnHeader chDisplayName;
    private System.Windows.Forms.ColumnHeader chDependings;
    private System.Windows.Forms.ListView lvServices;

		private System.ComponentModel.Container components = null;
		private bool onLoad = true;

		public Form1()
		{
			InitializeComponent();
		}

		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Vom Windows Form-Designer generierter Code
		/// <summary>
		/// Erforderliche Methode fr die Designeruntersttzung. 
		/// Der Inhalt der Methode darf nicht mit dem Code-Editor gendert werden.
		/// </summary>
		private void InitializeComponent()
		{
      this.lvServices = new System.Windows.Forms.ListView();
      this.chDisplayName = new System.Windows.Forms.ColumnHeader();
      this.chName = new System.Windows.Forms.ColumnHeader();
      this.chStatus = new System.Windows.Forms.ColumnHeader();
      this.chDependings = new System.Windows.Forms.ColumnHeader();
      this.SuspendLayout();
      // 
      // lvServices
      // 
      this.lvServices.CheckBoxes = true;
      this.lvServices.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
                                                                                 this.chDisplayName,
                                                                                 this.chName,
                                                                                 this.chStatus,
                                                                                 this.chDependings});
      this.lvServices.Dock = System.Windows.Forms.DockStyle.Fill;
      this.lvServices.FullRowSelect = true;
      this.lvServices.GridLines = true;
      this.lvServices.Location = new System.Drawing.Point(0, 0);
      this.lvServices.Name = "lvServices";
      this.lvServices.Size = new System.Drawing.Size(696, 446);
      this.lvServices.TabIndex = 0;
      this.lvServices.View = System.Windows.Forms.View.Details;
      this.lvServices.ItemCheck += new System.Windows.Forms.ItemCheckEventHandler(this.lvServices_ItemCheck);
      // 
      // chDisplayName
      // 
      this.chDisplayName.Text = "Anzeigename";
      this.chDisplayName.Width = 250;
      // 
      // chName
      // 
      this.chName.Text = "Name";
      this.chName.Width = 200;
      // 
      // chStatus
      // 
      this.chStatus.Text = "Status";
      // 
      // chDependings
      // 
      this.chDependings.Text = "Abhngigkeiten";
      this.chDependings.Width = 180;
      // 
      // Form1
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.ClientSize = new System.Drawing.Size(696, 446);
      this.Controls.Add(this.lvServices);
      this.Name = "Form1";
      this.Text = "Liste der laufenden Dienste";
      this.Load += new System.EventHandler(this.Form1_Load);
      this.ResumeLayout(false);

    }
		#endregion

		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

    private void Form1_Load(object sender, System.EventArgs e)
    {
      loadServices();      
    }

    private void loadServices()
    {
      onLoad = true;
      
      lvServices.Items.Clear();
      
      ListViewItem lvi;
    
      ServiceController[] scList = ServiceController.GetServices();

      foreach(ServiceController service in scList)
      {
        lvi = lvServices.Items.Add(service.DisplayName);
        lvi.SubItems.Add(service.ServiceName);
        lvi.SubItems.Add(service.Status.ToString());
        lvi.Checked = (service.Status == ServiceControllerStatus.Running);
        
        ServiceController[] dpServiceList = service.DependentServices;
        String dpServiceStr = "";
        foreach(ServiceController dpService in dpServiceList)
          dpServiceStr = dpServiceStr + dpService.ServiceName + ";";
        lvi.SubItems.Add(dpServiceStr);
      }
      onLoad = false;
    }

    private void lvServices_ItemCheck(object sender, System.Windows.Forms.ItemCheckEventArgs e)
    {
      if(!onLoad)
      {
        ServiceController sc;
        sc = new ServiceController(lvServices.Items[e.Index].SubItems[1].Text);
      
        if(e.NewValue == CheckState.Checked)
        {
          sc.Start();           
          sc.WaitForStatus(ServiceControllerStatus.Running);
        }
        else
        { 
          if(sc.CanStop)
          {
            sc.Stop();           
            sc.WaitForStatus(ServiceControllerStatus.Stopped);
          }  
        }  
      
        loadServices();
      }
    }
	}
}
